/**
 * Dasu Project
 *
 * File:         HVLogEntry.java
 * RCS:          $Id: HVLogEntry.java,v 1.5 2010/05/31 22:20:05 mas939 Exp $
 * Description:  HVLogEntry class (see below)
 * Author:       Zachary Bischof
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      May 31, 2010 at 5:21:11 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.ui
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2010, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.ui;

import java.io.Serializable;
import java.util.ArrayList;


/**
 * @author Zachary Bischof &lt;Zachary.Bischof@eecs.northwestern.edu&gt;
 *
 * The HVLogEntry class ...
 */

public class HVLogEntry implements Serializable {
	private long time;
	private String interferenceType;
	private String status;
	private String progress;
	private ArrayList<Object> descriptionObjects;
	
	public void HVLogEntry(){
		this.status = "unknown";
		this.status = "";
	}
	
	public void HVLogEntry(long time, String interferenceType, ArrayList<Object> descriptionObjects){
		this.time = time;
		this.interferenceType = interferenceType;
		this.descriptionObjects = descriptionObjects;
		this.status = "unknown";
		this.status = "";
	}
	public void HVLogEntry(long time, String interferenceType, String status, ArrayList<Object> descriptionObjects, String progress){
		this.time = time;
		this.interferenceType = interferenceType;
		this.status = status;
		if (progress == null)
			progress = "";
		this.progress = progress;
		this.descriptionObjects = descriptionObjects;
	}
	public void setTime(long time){
		this.time = time;
	}
	
	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}
	
	public String getProgress() {
		return progress;
	}

	public void setProgress(String progress) {
		this.progress = progress;
	}

	public void setType(String interferenceType){
		this.interferenceType = interferenceType;
	}
	
	public void setDescriptionObjects(ArrayList<Object> descriptionObjects){
		this.descriptionObjects = descriptionObjects;
	}
	
	public long getTime(){
		return time;
	}
	
	public String getType(){
		return interferenceType;
	}
	
	public ArrayList<Object> getDescriptionObjects(){
		return descriptionObjects;
	}
	
}
